<template>
  <form @submit.prevent="submitForm">
    <div :class="{invalid: !title.isValid}" class="form-control">
      <label for="title">Title</label>
      <input
          id="title"
          v-model.trim="title.val"
          type="text"
          @blur="clearValidity('title')"
      />
      <p v-if="!title.isValid">title must not be empty.</p>
    </div>
    <div class="form-control">
      <label for="codex-editor">Content</label>
      <div class="editorx_body">
        <div class id="codex-editor"/>
      </div>
    </div>
    <p v-if="!formIsValid">Please fix the above errors and submit again.</p>
    <base-button>Save</base-button>
  </form>
</template>

<script>
import EditorJS from "@editorjs/editorjs";
import Paragraph from "@editorjs/paragraph";
import * as img from '../../../plugin/editorjs-inline-image/bundle';
const GIF_URL= import.meta.env.VITE_GIF_API_URL
export default {
  emits: ['save-data'],
  data() {
    return {
      title: {
        val: '',
        isValid: true,
      },
      content: null,
      formIsValid: true,
    };
  },
  methods: {
    clearValidity(input) {
      this[input].isValid = true;
    },
    validateForm() {
      this.formIsValid = true;
      if (this.title.val === '') {
        this.title.isValid = false;
        this.formIsValid = false;
      }

    },
    async submitForm() {
      this.validateForm();
      if (!this.formIsValid) {
        return;
      }
      await editor.save().then(savedData => {
        this.content = savedData
      });
      const formData = {
        title: this.title.val,
        content: this.content,
      };
      this.$emit('save-data', formData);
    },
    myEditor() {
      window.editor = new EditorJS({
        holder: "codex-editor",
        autofocus: true,
        tools: {
          paragraph: {
            class: Paragraph,
            config: {
              placeholder: "."
            }
          },
          image: {
            class: InlineImage,
            inlineToolbar: true,
            config: {
              embed: {
                display: true,
              },
              unsplash: {
                apiUrl:GIF_URL,
              }
            }
          }
        }
      })
    },
  },
  mounted() {
    this.myEditor();
  }
}

</script>

<style scoped>
.form-control {
  margin: 0.5rem 0;
}

label {
  font-weight: bold;
  display: block;
  margin-bottom: 0.5rem;
}

input[type='checkbox'] + label {
  font-weight: normal;
  display: inline;
  margin: 0 0 0 0.5rem;
}

input,
textarea {
  display: block;
  width: 100%;
  border: 1px solid #ccc;
  font: inherit;
}

input:focus,
textarea:focus {
  background-color: #f0e6fd;
  outline: none;
  border-color: #3d008d;
}

input[type='checkbox'] {
  display: inline;
  width: auto;
  border: none;
}

input[type='checkbox']:focus {
  outline: #3d008d solid 1px;
}

h3 {
  margin: 0.5rem 0;
  font-size: 1rem;
}

.invalid label {
  color: red;
}

.invalid input,
.invalid textarea {
  border: 1px solid red;
}

</style>
